<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClientDespatchMethodInformation ArrayType
 * @subpackage Arrays
 */
class ArrayOfClientDespatchMethodInformation extends AbstractStructArrayBase
{
    /**
     * The ClientDespatchMethodInformation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClientDespatchMethodInformation[]
     */
    public $ClientDespatchMethodInformation;
    /**
     * Constructor method for ArrayOfClientDespatchMethodInformation
     * @uses ArrayOfClientDespatchMethodInformation::setClientDespatchMethodInformation()
     * @param \StructType\ClientDespatchMethodInformation[] $clientDespatchMethodInformation
     */
    public function __construct(array $clientDespatchMethodInformation = array())
    {
        $this
            ->setClientDespatchMethodInformation($clientDespatchMethodInformation);
    }
    /**
     * Get ClientDespatchMethodInformation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClientDespatchMethodInformation[]|null
     */
    public function getClientDespatchMethodInformation()
    {
        return isset($this->ClientDespatchMethodInformation) ? $this->ClientDespatchMethodInformation : null;
    }
    /**
     * This method is responsible for validating the values passed to the setClientDespatchMethodInformation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClientDespatchMethodInformation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClientDespatchMethodInformationForArrayConstraintsFromSetClientDespatchMethodInformation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfClientDespatchMethodInformationClientDespatchMethodInformationItem) {
            // validation for constraint: itemType
            if (!$arrayOfClientDespatchMethodInformationClientDespatchMethodInformationItem instanceof \StructType\ClientDespatchMethodInformation) {
                $invalidValues[] = is_object($arrayOfClientDespatchMethodInformationClientDespatchMethodInformationItem) ? get_class($arrayOfClientDespatchMethodInformationClientDespatchMethodInformationItem) : sprintf('%s(%s)', gettype($arrayOfClientDespatchMethodInformationClientDespatchMethodInformationItem), var_export($arrayOfClientDespatchMethodInformationClientDespatchMethodInformationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ClientDespatchMethodInformation property can only contain items of type \StructType\ClientDespatchMethodInformation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ClientDespatchMethodInformation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClientDespatchMethodInformation[] $clientDespatchMethodInformation
     * @return \ArrayType\ArrayOfClientDespatchMethodInformation
     */
    public function setClientDespatchMethodInformation(array $clientDespatchMethodInformation = array())
    {
        // validation for constraint: array
        if ('' !== ($clientDespatchMethodInformationArrayErrorMessage = self::validateClientDespatchMethodInformationForArrayConstraintsFromSetClientDespatchMethodInformation($clientDespatchMethodInformation))) {
            throw new \InvalidArgumentException($clientDespatchMethodInformationArrayErrorMessage, __LINE__);
        }
        if (is_null($clientDespatchMethodInformation) || (is_array($clientDespatchMethodInformation) && empty($clientDespatchMethodInformation))) {
            unset($this->ClientDespatchMethodInformation);
        } else {
            $this->ClientDespatchMethodInformation = $clientDespatchMethodInformation;
        }
        return $this;
    }
    /**
     * Add item to ClientDespatchMethodInformation value
     * @throws \InvalidArgumentException
     * @param \StructType\ClientDespatchMethodInformation $item
     * @return \ArrayType\ArrayOfClientDespatchMethodInformation
     */
    public function addToClientDespatchMethodInformation(\StructType\ClientDespatchMethodInformation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClientDespatchMethodInformation) {
            throw new \InvalidArgumentException(sprintf('The ClientDespatchMethodInformation property can only contain items of type \StructType\ClientDespatchMethodInformation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ClientDespatchMethodInformation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClientDespatchMethodInformation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClientDespatchMethodInformation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClientDespatchMethodInformation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClientDespatchMethodInformation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClientDespatchMethodInformation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ClientDespatchMethodInformation
     */
    public function getAttributeName()
    {
        return 'ClientDespatchMethodInformation';
    }
}
