<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCreatelabelresponse ArrayType
 * @subpackage Arrays
 */
class ArrayOfCreatelabelresponse extends AbstractStructArrayBase
{
    /**
     * The createlabelresponse
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Createlabelresponse[]
     */
    public $createlabelresponse;
    /**
     * Constructor method for ArrayOfCreatelabelresponse
     * @uses ArrayOfCreatelabelresponse::setCreatelabelresponse()
     * @param \StructType\Createlabelresponse[] $createlabelresponse
     */
    public function __construct(array $createlabelresponse = array())
    {
        $this
            ->setCreatelabelresponse($createlabelresponse);
    }
    /**
     * Get createlabelresponse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Createlabelresponse[]|null
     */
    public function getCreatelabelresponse()
    {
        return isset($this->createlabelresponse) ? $this->createlabelresponse : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCreatelabelresponse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCreatelabelresponse method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCreatelabelresponseForArrayConstraintsFromSetCreatelabelresponse(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCreatelabelresponseCreatelabelresponseItem) {
            // validation for constraint: itemType
            if (!$arrayOfCreatelabelresponseCreatelabelresponseItem instanceof \StructType\Createlabelresponse) {
                $invalidValues[] = is_object($arrayOfCreatelabelresponseCreatelabelresponseItem) ? get_class($arrayOfCreatelabelresponseCreatelabelresponseItem) : sprintf('%s(%s)', gettype($arrayOfCreatelabelresponseCreatelabelresponseItem), var_export($arrayOfCreatelabelresponseCreatelabelresponseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The createlabelresponse property can only contain items of type \StructType\Createlabelresponse, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set createlabelresponse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Createlabelresponse[] $createlabelresponse
     * @return \ArrayType\ArrayOfCreatelabelresponse
     */
    public function setCreatelabelresponse(array $createlabelresponse = array())
    {
        // validation for constraint: array
        if ('' !== ($createlabelresponseArrayErrorMessage = self::validateCreatelabelresponseForArrayConstraintsFromSetCreatelabelresponse($createlabelresponse))) {
            throw new \InvalidArgumentException($createlabelresponseArrayErrorMessage, __LINE__);
        }
        if (is_null($createlabelresponse) || (is_array($createlabelresponse) && empty($createlabelresponse))) {
            unset($this->createlabelresponse);
        } else {
            $this->createlabelresponse = $createlabelresponse;
        }
        return $this;
    }
    /**
     * Add item to createlabelresponse value
     * @throws \InvalidArgumentException
     * @param \StructType\Createlabelresponse $item
     * @return \ArrayType\ArrayOfCreatelabelresponse
     */
    public function addToCreatelabelresponse(\StructType\Createlabelresponse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Createlabelresponse) {
            throw new \InvalidArgumentException(sprintf('The createlabelresponse property can only contain items of type \StructType\Createlabelresponse, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->createlabelresponse[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Createlabelresponse|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Createlabelresponse|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Createlabelresponse|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Createlabelresponse|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Createlabelresponse|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string createlabelresponse
     */
    public function getAttributeName()
    {
        return 'createlabelresponse';
    }
}
