<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEvaluateDespatchServicesResponse ArrayType
 * @subpackage Arrays
 */
class ArrayOfEvaluateDespatchServicesResponse extends AbstractStructArrayBase
{
    /**
     * The EvaluateDespatchServicesResponse
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EvaluateDespatchServicesResponse[]
     */
    public $EvaluateDespatchServicesResponse;
    /**
     * Constructor method for ArrayOfEvaluateDespatchServicesResponse
     * @uses ArrayOfEvaluateDespatchServicesResponse::setEvaluateDespatchServicesResponse()
     * @param \StructType\EvaluateDespatchServicesResponse[] $evaluateDespatchServicesResponse
     */
    public function __construct(array $evaluateDespatchServicesResponse = array())
    {
        $this
            ->setEvaluateDespatchServicesResponse($evaluateDespatchServicesResponse);
    }
    /**
     * Get EvaluateDespatchServicesResponse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EvaluateDespatchServicesResponse[]|null
     */
    public function getEvaluateDespatchServicesResponse()
    {
        return isset($this->EvaluateDespatchServicesResponse) ? $this->EvaluateDespatchServicesResponse : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEvaluateDespatchServicesResponse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEvaluateDespatchServicesResponse method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEvaluateDespatchServicesResponseForArrayConstraintsFromSetEvaluateDespatchServicesResponse(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEvaluateDespatchServicesResponseEvaluateDespatchServicesResponseItem) {
            // validation for constraint: itemType
            if (!$arrayOfEvaluateDespatchServicesResponseEvaluateDespatchServicesResponseItem instanceof \StructType\EvaluateDespatchServicesResponse) {
                $invalidValues[] = is_object($arrayOfEvaluateDespatchServicesResponseEvaluateDespatchServicesResponseItem) ? get_class($arrayOfEvaluateDespatchServicesResponseEvaluateDespatchServicesResponseItem) : sprintf('%s(%s)', gettype($arrayOfEvaluateDespatchServicesResponseEvaluateDespatchServicesResponseItem), var_export($arrayOfEvaluateDespatchServicesResponseEvaluateDespatchServicesResponseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EvaluateDespatchServicesResponse property can only contain items of type \StructType\EvaluateDespatchServicesResponse, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EvaluateDespatchServicesResponse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EvaluateDespatchServicesResponse[] $evaluateDespatchServicesResponse
     * @return \ArrayType\ArrayOfEvaluateDespatchServicesResponse
     */
    public function setEvaluateDespatchServicesResponse(array $evaluateDespatchServicesResponse = array())
    {
        // validation for constraint: array
        if ('' !== ($evaluateDespatchServicesResponseArrayErrorMessage = self::validateEvaluateDespatchServicesResponseForArrayConstraintsFromSetEvaluateDespatchServicesResponse($evaluateDespatchServicesResponse))) {
            throw new \InvalidArgumentException($evaluateDespatchServicesResponseArrayErrorMessage, __LINE__);
        }
        if (is_null($evaluateDespatchServicesResponse) || (is_array($evaluateDespatchServicesResponse) && empty($evaluateDespatchServicesResponse))) {
            unset($this->EvaluateDespatchServicesResponse);
        } else {
            $this->EvaluateDespatchServicesResponse = $evaluateDespatchServicesResponse;
        }
        return $this;
    }
    /**
     * Add item to EvaluateDespatchServicesResponse value
     * @throws \InvalidArgumentException
     * @param \StructType\EvaluateDespatchServicesResponse $item
     * @return \ArrayType\ArrayOfEvaluateDespatchServicesResponse
     */
    public function addToEvaluateDespatchServicesResponse(\StructType\EvaluateDespatchServicesResponse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EvaluateDespatchServicesResponse) {
            throw new \InvalidArgumentException(sprintf('The EvaluateDespatchServicesResponse property can only contain items of type \StructType\EvaluateDespatchServicesResponse, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EvaluateDespatchServicesResponse[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EvaluateDespatchServicesResponse|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EvaluateDespatchServicesResponse|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EvaluateDespatchServicesResponse|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EvaluateDespatchServicesResponse|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EvaluateDespatchServicesResponse|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EvaluateDespatchServicesResponse
     */
    public function getAttributeName()
    {
        return 'EvaluateDespatchServicesResponse';
    }
}
