<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfKeyValuePairOfstringanyType ArrayType
 * @subpackage Arrays
 */
class ArrayOfKeyValuePairOfstringanyType extends AbstractStructArrayBase
{
    /**
     * The KeyValuePairOfstringanyType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\KeyValuePairOfstringanyType[]
     */
    public $KeyValuePairOfstringanyType;
    /**
     * Constructor method for ArrayOfKeyValuePairOfstringanyType
     * @uses ArrayOfKeyValuePairOfstringanyType::setKeyValuePairOfstringanyType()
     * @param \StructType\KeyValuePairOfstringanyType[] $keyValuePairOfstringanyType
     */
    public function __construct(array $keyValuePairOfstringanyType = array())
    {
        $this
            ->setKeyValuePairOfstringanyType($keyValuePairOfstringanyType);
    }
    /**
     * Get KeyValuePairOfstringanyType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\KeyValuePairOfstringanyType[]|null
     */
    public function getKeyValuePairOfstringanyType()
    {
        return isset($this->KeyValuePairOfstringanyType) ? $this->KeyValuePairOfstringanyType : null;
    }
    /**
     * This method is responsible for validating the values passed to the setKeyValuePairOfstringanyType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKeyValuePairOfstringanyType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKeyValuePairOfstringanyTypeForArrayConstraintsFromSetKeyValuePairOfstringanyType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfKeyValuePairOfstringanyTypeKeyValuePairOfstringanyTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfKeyValuePairOfstringanyTypeKeyValuePairOfstringanyTypeItem instanceof \StructType\KeyValuePairOfstringanyType) {
                $invalidValues[] = is_object($arrayOfKeyValuePairOfstringanyTypeKeyValuePairOfstringanyTypeItem) ? get_class($arrayOfKeyValuePairOfstringanyTypeKeyValuePairOfstringanyTypeItem) : sprintf('%s(%s)', gettype($arrayOfKeyValuePairOfstringanyTypeKeyValuePairOfstringanyTypeItem), var_export($arrayOfKeyValuePairOfstringanyTypeKeyValuePairOfstringanyTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The KeyValuePairOfstringanyType property can only contain items of type \StructType\KeyValuePairOfstringanyType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set KeyValuePairOfstringanyType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\KeyValuePairOfstringanyType[] $keyValuePairOfstringanyType
     * @return \ArrayType\ArrayOfKeyValuePairOfstringanyType
     */
    public function setKeyValuePairOfstringanyType(array $keyValuePairOfstringanyType = array())
    {
        // validation for constraint: array
        if ('' !== ($keyValuePairOfstringanyTypeArrayErrorMessage = self::validateKeyValuePairOfstringanyTypeForArrayConstraintsFromSetKeyValuePairOfstringanyType($keyValuePairOfstringanyType))) {
            throw new \InvalidArgumentException($keyValuePairOfstringanyTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($keyValuePairOfstringanyType) || (is_array($keyValuePairOfstringanyType) && empty($keyValuePairOfstringanyType))) {
            unset($this->KeyValuePairOfstringanyType);
        } else {
            $this->KeyValuePairOfstringanyType = $keyValuePairOfstringanyType;
        }
        return $this;
    }
    /**
     * Add item to KeyValuePairOfstringanyType value
     * @throws \InvalidArgumentException
     * @param \StructType\KeyValuePairOfstringanyType $item
     * @return \ArrayType\ArrayOfKeyValuePairOfstringanyType
     */
    public function addToKeyValuePairOfstringanyType(\StructType\KeyValuePairOfstringanyType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\KeyValuePairOfstringanyType) {
            throw new \InvalidArgumentException(sprintf('The KeyValuePairOfstringanyType property can only contain items of type \StructType\KeyValuePairOfstringanyType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->KeyValuePairOfstringanyType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\KeyValuePairOfstringanyType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\KeyValuePairOfstringanyType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\KeyValuePairOfstringanyType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\KeyValuePairOfstringanyType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\KeyValuePairOfstringanyType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string KeyValuePairOfstringanyType
     */
    public function getAttributeName()
    {
        return 'KeyValuePairOfstringanyType';
    }
}
