<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLabelDesc ArrayType
 * @subpackage Arrays
 */
class ArrayOfLabelDesc extends AbstractStructArrayBase
{
    /**
     * The LabelDesc
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LabelDesc[]
     */
    public $LabelDesc;
    /**
     * Constructor method for ArrayOfLabelDesc
     * @uses ArrayOfLabelDesc::setLabelDesc()
     * @param \StructType\LabelDesc[] $labelDesc
     */
    public function __construct(array $labelDesc = array())
    {
        $this
            ->setLabelDesc($labelDesc);
    }
    /**
     * Get LabelDesc value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LabelDesc[]|null
     */
    public function getLabelDesc()
    {
        return isset($this->LabelDesc) ? $this->LabelDesc : null;
    }
    /**
     * This method is responsible for validating the values passed to the setLabelDesc method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLabelDesc method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLabelDescForArrayConstraintsFromSetLabelDesc(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfLabelDescLabelDescItem) {
            // validation for constraint: itemType
            if (!$arrayOfLabelDescLabelDescItem instanceof \StructType\LabelDesc) {
                $invalidValues[] = is_object($arrayOfLabelDescLabelDescItem) ? get_class($arrayOfLabelDescLabelDescItem) : sprintf('%s(%s)', gettype($arrayOfLabelDescLabelDescItem), var_export($arrayOfLabelDescLabelDescItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LabelDesc property can only contain items of type \StructType\LabelDesc, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LabelDesc value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LabelDesc[] $labelDesc
     * @return \ArrayType\ArrayOfLabelDesc
     */
    public function setLabelDesc(array $labelDesc = array())
    {
        // validation for constraint: array
        if ('' !== ($labelDescArrayErrorMessage = self::validateLabelDescForArrayConstraintsFromSetLabelDesc($labelDesc))) {
            throw new \InvalidArgumentException($labelDescArrayErrorMessage, __LINE__);
        }
        if (is_null($labelDesc) || (is_array($labelDesc) && empty($labelDesc))) {
            unset($this->LabelDesc);
        } else {
            $this->LabelDesc = $labelDesc;
        }
        return $this;
    }
    /**
     * Add item to LabelDesc value
     * @throws \InvalidArgumentException
     * @param \StructType\LabelDesc $item
     * @return \ArrayType\ArrayOfLabelDesc
     */
    public function addToLabelDesc(\StructType\LabelDesc $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LabelDesc) {
            throw new \InvalidArgumentException(sprintf('The LabelDesc property can only contain items of type \StructType\LabelDesc, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LabelDesc[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LabelDesc|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LabelDesc|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LabelDesc|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LabelDesc|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LabelDesc|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LabelDesc
     */
    public function getAttributeName()
    {
        return 'LabelDesc';
    }
}
