<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfParcelProduct ArrayType
 * @subpackage Arrays
 */
class ArrayOfParcelProduct extends AbstractStructArrayBase
{
    /**
     * The parcelProduct
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ParcelProduct[]
     */
    public $parcelProduct;
    /**
     * Constructor method for ArrayOfParcelProduct
     * @uses ArrayOfParcelProduct::setParcelProduct()
     * @param \StructType\ParcelProduct[] $parcelProduct
     */
    public function __construct(array $parcelProduct = array())
    {
        $this
            ->setParcelProduct($parcelProduct);
    }
    /**
     * Get parcelProduct value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ParcelProduct[]|null
     */
    public function getParcelProduct()
    {
        return isset($this->parcelProduct) ? $this->parcelProduct : null;
    }
    /**
     * This method is responsible for validating the values passed to the setParcelProduct method
     * This method is willingly generated in order to preserve the one-line inline validation within the setParcelProduct method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateParcelProductForArrayConstraintsFromSetParcelProduct(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfParcelProductParcelProductItem) {
            // validation for constraint: itemType
            if (!$arrayOfParcelProductParcelProductItem instanceof \StructType\ParcelProduct) {
                $invalidValues[] = is_object($arrayOfParcelProductParcelProductItem) ? get_class($arrayOfParcelProductParcelProductItem) : sprintf('%s(%s)', gettype($arrayOfParcelProductParcelProductItem), var_export($arrayOfParcelProductParcelProductItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The parcelProduct property can only contain items of type \StructType\ParcelProduct, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set parcelProduct value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ParcelProduct[] $parcelProduct
     * @return \ArrayType\ArrayOfParcelProduct
     */
    public function setParcelProduct(array $parcelProduct = array())
    {
        // validation for constraint: array
        if ('' !== ($parcelProductArrayErrorMessage = self::validateParcelProductForArrayConstraintsFromSetParcelProduct($parcelProduct))) {
            throw new \InvalidArgumentException($parcelProductArrayErrorMessage, __LINE__);
        }
        if (is_null($parcelProduct) || (is_array($parcelProduct) && empty($parcelProduct))) {
            unset($this->parcelProduct);
        } else {
            $this->parcelProduct = $parcelProduct;
        }
        return $this;
    }
    /**
     * Add item to parcelProduct value
     * @throws \InvalidArgumentException
     * @param \StructType\ParcelProduct $item
     * @return \ArrayType\ArrayOfParcelProduct
     */
    public function addToParcelProduct(\StructType\ParcelProduct $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ParcelProduct) {
            throw new \InvalidArgumentException(sprintf('The parcelProduct property can only contain items of type \StructType\ParcelProduct, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->parcelProduct[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ParcelProduct|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ParcelProduct|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ParcelProduct|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ParcelProduct|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ParcelProduct|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string parcelProduct
     */
    public function getAttributeName()
    {
        return 'parcelProduct';
    }
}
