<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPrintLabelResponse ArrayType
 * @subpackage Arrays
 */
class ArrayOfPrintLabelResponse extends AbstractStructArrayBase
{
    /**
     * The PrintLabelResponse
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PrintLabelResponse[]
     */
    public $PrintLabelResponse;
    /**
     * Constructor method for ArrayOfPrintLabelResponse
     * @uses ArrayOfPrintLabelResponse::setPrintLabelResponse()
     * @param \StructType\PrintLabelResponse[] $printLabelResponse
     */
    public function __construct(array $printLabelResponse = array())
    {
        $this
            ->setPrintLabelResponse($printLabelResponse);
    }
    /**
     * Get PrintLabelResponse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PrintLabelResponse[]|null
     */
    public function getPrintLabelResponse()
    {
        return isset($this->PrintLabelResponse) ? $this->PrintLabelResponse : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPrintLabelResponse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPrintLabelResponse method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePrintLabelResponseForArrayConstraintsFromSetPrintLabelResponse(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPrintLabelResponsePrintLabelResponseItem) {
            // validation for constraint: itemType
            if (!$arrayOfPrintLabelResponsePrintLabelResponseItem instanceof \StructType\PrintLabelResponse) {
                $invalidValues[] = is_object($arrayOfPrintLabelResponsePrintLabelResponseItem) ? get_class($arrayOfPrintLabelResponsePrintLabelResponseItem) : sprintf('%s(%s)', gettype($arrayOfPrintLabelResponsePrintLabelResponseItem), var_export($arrayOfPrintLabelResponsePrintLabelResponseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PrintLabelResponse property can only contain items of type \StructType\PrintLabelResponse, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PrintLabelResponse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PrintLabelResponse[] $printLabelResponse
     * @return \ArrayType\ArrayOfPrintLabelResponse
     */
    public function setPrintLabelResponse(array $printLabelResponse = array())
    {
        // validation for constraint: array
        if ('' !== ($printLabelResponseArrayErrorMessage = self::validatePrintLabelResponseForArrayConstraintsFromSetPrintLabelResponse($printLabelResponse))) {
            throw new \InvalidArgumentException($printLabelResponseArrayErrorMessage, __LINE__);
        }
        if (is_null($printLabelResponse) || (is_array($printLabelResponse) && empty($printLabelResponse))) {
            unset($this->PrintLabelResponse);
        } else {
            $this->PrintLabelResponse = $printLabelResponse;
        }
        return $this;
    }
    /**
     * Add item to PrintLabelResponse value
     * @throws \InvalidArgumentException
     * @param \StructType\PrintLabelResponse $item
     * @return \ArrayType\ArrayOfPrintLabelResponse
     */
    public function addToPrintLabelResponse(\StructType\PrintLabelResponse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PrintLabelResponse) {
            throw new \InvalidArgumentException(sprintf('The PrintLabelResponse property can only contain items of type \StructType\PrintLabelResponse, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PrintLabelResponse[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PrintLabelResponse|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PrintLabelResponse|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PrintLabelResponse|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PrintLabelResponse|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PrintLabelResponse|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PrintLabelResponse
     */
    public function getAttributeName()
    {
        return 'PrintLabelResponse';
    }
}
