<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProduct1 ArrayType
 * @subpackage Arrays
 */
class ArrayOfProduct1 extends AbstractStructArrayBase
{
    /**
     * The product1
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Product1[]
     */
    public $product1;
    /**
     * Constructor method for ArrayOfProduct1
     * @uses ArrayOfProduct1::setProduct1()
     * @param \StructType\Product1[] $product1
     */
    public function __construct(array $product1 = array())
    {
        $this
            ->setProduct1($product1);
    }
    /**
     * Get product1 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Product1[]|null
     */
    public function getProduct1()
    {
        return isset($this->product1) ? $this->product1 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setProduct1 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProduct1 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProduct1ForArrayConstraintsFromSetProduct1(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfProduct1Product1Item) {
            // validation for constraint: itemType
            if (!$arrayOfProduct1Product1Item instanceof \StructType\Product1) {
                $invalidValues[] = is_object($arrayOfProduct1Product1Item) ? get_class($arrayOfProduct1Product1Item) : sprintf('%s(%s)', gettype($arrayOfProduct1Product1Item), var_export($arrayOfProduct1Product1Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The product1 property can only contain items of type \StructType\Product1, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set product1 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Product1[] $product1
     * @return \ArrayType\ArrayOfProduct1
     */
    public function setProduct1(array $product1 = array())
    {
        // validation for constraint: array
        if ('' !== ($product1ArrayErrorMessage = self::validateProduct1ForArrayConstraintsFromSetProduct1($product1))) {
            throw new \InvalidArgumentException($product1ArrayErrorMessage, __LINE__);
        }
        if (is_null($product1) || (is_array($product1) && empty($product1))) {
            unset($this->product1);
        } else {
            $this->product1 = $product1;
        }
        return $this;
    }
    /**
     * Add item to product1 value
     * @throws \InvalidArgumentException
     * @param \StructType\Product1 $item
     * @return \ArrayType\ArrayOfProduct1
     */
    public function addToProduct1(\StructType\Product1 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Product1) {
            throw new \InvalidArgumentException(sprintf('The product1 property can only contain items of type \StructType\Product1, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->product1[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Product1|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Product1|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Product1|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Product1|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Product1|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string product1
     */
    public function getAttributeName()
    {
        return 'product1';
    }
}
