<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfScriptsRun ArrayType
 * @subpackage Arrays
 */
class ArrayOfScriptsRun extends AbstractStructArrayBase
{
    /**
     * The ScriptsRun
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ScriptsRun[]
     */
    public $ScriptsRun;
    /**
     * Constructor method for ArrayOfScriptsRun
     * @uses ArrayOfScriptsRun::setScriptsRun()
     * @param \StructType\ScriptsRun[] $scriptsRun
     */
    public function __construct(array $scriptsRun = array())
    {
        $this
            ->setScriptsRun($scriptsRun);
    }
    /**
     * Get ScriptsRun value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ScriptsRun[]|null
     */
    public function getScriptsRun()
    {
        return isset($this->ScriptsRun) ? $this->ScriptsRun : null;
    }
    /**
     * This method is responsible for validating the values passed to the setScriptsRun method
     * This method is willingly generated in order to preserve the one-line inline validation within the setScriptsRun method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateScriptsRunForArrayConstraintsFromSetScriptsRun(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfScriptsRunScriptsRunItem) {
            // validation for constraint: itemType
            if (!$arrayOfScriptsRunScriptsRunItem instanceof \StructType\ScriptsRun) {
                $invalidValues[] = is_object($arrayOfScriptsRunScriptsRunItem) ? get_class($arrayOfScriptsRunScriptsRunItem) : sprintf('%s(%s)', gettype($arrayOfScriptsRunScriptsRunItem), var_export($arrayOfScriptsRunScriptsRunItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ScriptsRun property can only contain items of type \StructType\ScriptsRun, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ScriptsRun value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ScriptsRun[] $scriptsRun
     * @return \ArrayType\ArrayOfScriptsRun
     */
    public function setScriptsRun(array $scriptsRun = array())
    {
        // validation for constraint: array
        if ('' !== ($scriptsRunArrayErrorMessage = self::validateScriptsRunForArrayConstraintsFromSetScriptsRun($scriptsRun))) {
            throw new \InvalidArgumentException($scriptsRunArrayErrorMessage, __LINE__);
        }
        if (is_null($scriptsRun) || (is_array($scriptsRun) && empty($scriptsRun))) {
            unset($this->ScriptsRun);
        } else {
            $this->ScriptsRun = $scriptsRun;
        }
        return $this;
    }
    /**
     * Add item to ScriptsRun value
     * @throws \InvalidArgumentException
     * @param \StructType\ScriptsRun $item
     * @return \ArrayType\ArrayOfScriptsRun
     */
    public function addToScriptsRun(\StructType\ScriptsRun $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ScriptsRun) {
            throw new \InvalidArgumentException(sprintf('The ScriptsRun property can only contain items of type \StructType\ScriptsRun, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ScriptsRun[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ScriptsRun|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ScriptsRun|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ScriptsRun|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ScriptsRun|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ScriptsRun|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ScriptsRun
     */
    public function getAttributeName()
    {
        return 'ScriptsRun';
    }
}
