<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSiteDespatch ArrayType
 * @subpackage Arrays
 */
class ArrayOfSiteDespatch extends AbstractStructArrayBase
{
    /**
     * The SiteDespatch
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SiteDespatch[]
     */
    public $SiteDespatch;
    /**
     * Constructor method for ArrayOfSiteDespatch
     * @uses ArrayOfSiteDespatch::setSiteDespatch()
     * @param \StructType\SiteDespatch[] $siteDespatch
     */
    public function __construct(array $siteDespatch = array())
    {
        $this
            ->setSiteDespatch($siteDespatch);
    }
    /**
     * Get SiteDespatch value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SiteDespatch[]|null
     */
    public function getSiteDespatch()
    {
        return isset($this->SiteDespatch) ? $this->SiteDespatch : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSiteDespatch method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSiteDespatch method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSiteDespatchForArrayConstraintsFromSetSiteDespatch(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSiteDespatchSiteDespatchItem) {
            // validation for constraint: itemType
            if (!$arrayOfSiteDespatchSiteDespatchItem instanceof \StructType\SiteDespatch) {
                $invalidValues[] = is_object($arrayOfSiteDespatchSiteDespatchItem) ? get_class($arrayOfSiteDespatchSiteDespatchItem) : sprintf('%s(%s)', gettype($arrayOfSiteDespatchSiteDespatchItem), var_export($arrayOfSiteDespatchSiteDespatchItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SiteDespatch property can only contain items of type \StructType\SiteDespatch, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SiteDespatch value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SiteDespatch[] $siteDespatch
     * @return \ArrayType\ArrayOfSiteDespatch
     */
    public function setSiteDespatch(array $siteDespatch = array())
    {
        // validation for constraint: array
        if ('' !== ($siteDespatchArrayErrorMessage = self::validateSiteDespatchForArrayConstraintsFromSetSiteDespatch($siteDespatch))) {
            throw new \InvalidArgumentException($siteDespatchArrayErrorMessage, __LINE__);
        }
        if (is_null($siteDespatch) || (is_array($siteDespatch) && empty($siteDespatch))) {
            unset($this->SiteDespatch);
        } else {
            $this->SiteDespatch = $siteDespatch;
        }
        return $this;
    }
    /**
     * Add item to SiteDespatch value
     * @throws \InvalidArgumentException
     * @param \StructType\SiteDespatch $item
     * @return \ArrayType\ArrayOfSiteDespatch
     */
    public function addToSiteDespatch(\StructType\SiteDespatch $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SiteDespatch) {
            throw new \InvalidArgumentException(sprintf('The SiteDespatch property can only contain items of type \StructType\SiteDespatch, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SiteDespatch[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SiteDespatch|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SiteDespatch|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SiteDespatch|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SiteDespatch|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SiteDespatch|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SiteDespatch
     */
    public function getAttributeName()
    {
        return 'SiteDespatch';
    }
}
