<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSiteDespatchProduct ArrayType
 * @subpackage Arrays
 */
class ArrayOfSiteDespatchProduct extends AbstractStructArrayBase
{
    /**
     * The SiteDespatchProduct
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SiteDespatchProduct[]
     */
    public $SiteDespatchProduct;
    /**
     * Constructor method for ArrayOfSiteDespatchProduct
     * @uses ArrayOfSiteDespatchProduct::setSiteDespatchProduct()
     * @param \StructType\SiteDespatchProduct[] $siteDespatchProduct
     */
    public function __construct(array $siteDespatchProduct = array())
    {
        $this
            ->setSiteDespatchProduct($siteDespatchProduct);
    }
    /**
     * Get SiteDespatchProduct value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SiteDespatchProduct[]|null
     */
    public function getSiteDespatchProduct()
    {
        return isset($this->SiteDespatchProduct) ? $this->SiteDespatchProduct : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSiteDespatchProduct method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSiteDespatchProduct method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSiteDespatchProductForArrayConstraintsFromSetSiteDespatchProduct(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSiteDespatchProductSiteDespatchProductItem) {
            // validation for constraint: itemType
            if (!$arrayOfSiteDespatchProductSiteDespatchProductItem instanceof \StructType\SiteDespatchProduct) {
                $invalidValues[] = is_object($arrayOfSiteDespatchProductSiteDespatchProductItem) ? get_class($arrayOfSiteDespatchProductSiteDespatchProductItem) : sprintf('%s(%s)', gettype($arrayOfSiteDespatchProductSiteDespatchProductItem), var_export($arrayOfSiteDespatchProductSiteDespatchProductItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SiteDespatchProduct property can only contain items of type \StructType\SiteDespatchProduct, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SiteDespatchProduct value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SiteDespatchProduct[] $siteDespatchProduct
     * @return \ArrayType\ArrayOfSiteDespatchProduct
     */
    public function setSiteDespatchProduct(array $siteDespatchProduct = array())
    {
        // validation for constraint: array
        if ('' !== ($siteDespatchProductArrayErrorMessage = self::validateSiteDespatchProductForArrayConstraintsFromSetSiteDespatchProduct($siteDespatchProduct))) {
            throw new \InvalidArgumentException($siteDespatchProductArrayErrorMessage, __LINE__);
        }
        if (is_null($siteDespatchProduct) || (is_array($siteDespatchProduct) && empty($siteDespatchProduct))) {
            unset($this->SiteDespatchProduct);
        } else {
            $this->SiteDespatchProduct = $siteDespatchProduct;
        }
        return $this;
    }
    /**
     * Add item to SiteDespatchProduct value
     * @throws \InvalidArgumentException
     * @param \StructType\SiteDespatchProduct $item
     * @return \ArrayType\ArrayOfSiteDespatchProduct
     */
    public function addToSiteDespatchProduct(\StructType\SiteDespatchProduct $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SiteDespatchProduct) {
            throw new \InvalidArgumentException(sprintf('The SiteDespatchProduct property can only contain items of type \StructType\SiteDespatchProduct, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SiteDespatchProduct[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SiteDespatchProduct|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SiteDespatchProduct|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SiteDespatchProduct|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SiteDespatchProduct|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SiteDespatchProduct|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SiteDespatchProduct
     */
    public function getAttributeName()
    {
        return 'SiteDespatchProduct';
    }
}
