<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSurchargeMember ArrayType
 * @subpackage Arrays
 */
class ArrayOfSurchargeMember extends AbstractStructArrayBase
{
    /**
     * The SurchargeMember
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SurchargeMember[]
     */
    public $SurchargeMember;
    /**
     * Constructor method for ArrayOfSurchargeMember
     * @uses ArrayOfSurchargeMember::setSurchargeMember()
     * @param \StructType\SurchargeMember[] $surchargeMember
     */
    public function __construct(array $surchargeMember = array())
    {
        $this
            ->setSurchargeMember($surchargeMember);
    }
    /**
     * Get SurchargeMember value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SurchargeMember[]|null
     */
    public function getSurchargeMember()
    {
        return isset($this->SurchargeMember) ? $this->SurchargeMember : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSurchargeMember method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSurchargeMember method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSurchargeMemberForArrayConstraintsFromSetSurchargeMember(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSurchargeMemberSurchargeMemberItem) {
            // validation for constraint: itemType
            if (!$arrayOfSurchargeMemberSurchargeMemberItem instanceof \StructType\SurchargeMember) {
                $invalidValues[] = is_object($arrayOfSurchargeMemberSurchargeMemberItem) ? get_class($arrayOfSurchargeMemberSurchargeMemberItem) : sprintf('%s(%s)', gettype($arrayOfSurchargeMemberSurchargeMemberItem), var_export($arrayOfSurchargeMemberSurchargeMemberItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SurchargeMember property can only contain items of type \StructType\SurchargeMember, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SurchargeMember value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SurchargeMember[] $surchargeMember
     * @return \ArrayType\ArrayOfSurchargeMember
     */
    public function setSurchargeMember(array $surchargeMember = array())
    {
        // validation for constraint: array
        if ('' !== ($surchargeMemberArrayErrorMessage = self::validateSurchargeMemberForArrayConstraintsFromSetSurchargeMember($surchargeMember))) {
            throw new \InvalidArgumentException($surchargeMemberArrayErrorMessage, __LINE__);
        }
        if (is_null($surchargeMember) || (is_array($surchargeMember) && empty($surchargeMember))) {
            unset($this->SurchargeMember);
        } else {
            $this->SurchargeMember = $surchargeMember;
        }
        return $this;
    }
    /**
     * Add item to SurchargeMember value
     * @throws \InvalidArgumentException
     * @param \StructType\SurchargeMember $item
     * @return \ArrayType\ArrayOfSurchargeMember
     */
    public function addToSurchargeMember(\StructType\SurchargeMember $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SurchargeMember) {
            throw new \InvalidArgumentException(sprintf('The SurchargeMember property can only contain items of type \StructType\SurchargeMember, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SurchargeMember[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SurchargeMember|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SurchargeMember|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SurchargeMember|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SurchargeMember|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SurchargeMember|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SurchargeMember
     */
    public function getAttributeName()
    {
        return 'SurchargeMember';
    }
}
