<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'DiagnosticsFull' => '\\StructType\\DiagnosticsFull',
            'ExtensionDataObject' => '\\StructType\\ExtensionDataObject',
            'DiagnosticsSpeedTest' => '\\StructType\\DiagnosticsSpeedTest',
            'PagedReturnListOfScriptsRunN5ezemxU' => '\\StructType\\PagedReturnListOfScriptsRunN5ezemxU',
            'ArrayOfScriptsRun' => '\\ArrayType\\ArrayOfScriptsRun',
            'ScriptsRun' => '\\StructType\\ScriptsRun',
            'ArrayOfLabelDesc' => '\\ArrayType\\ArrayOfLabelDesc',
            'LabelDesc' => '\\StructType\\LabelDesc',
            'ClearCacheRequest' => '\\StructType\\ClearCacheRequest',
            'DataUpdateResultArgsOfboolean' => '\\StructType\\DataUpdateResultArgsOfboolean',
            'DataResultArgsOfboolean' => '\\StructType\\DataResultArgsOfboolean',
            'ResultArgs' => '\\StructType\\ResultArgs',
            'DespatchAllocatingRequest' => '\\StructType\\DespatchAllocatingRequest',
            'DespatchBaseRequest' => '\\StructType\\DespatchBaseRequest',
            'AddressRequest' => '\\StructType\\AddressRequest',
            'DespatchAllocatingResponse' => '\\StructType\\DespatchAllocatingResponse',
            'ArrayOfClientDespatchMethodInformation' => '\\ArrayType\\ArrayOfClientDespatchMethodInformation',
            'ClientDespatchMethodInformation' => '\\StructType\\ClientDespatchMethodInformation',
            'ArrayOfSurchargeMember' => '\\ArrayType\\ArrayOfSurchargeMember',
            'SurchargeMember' => '\\StructType\\SurchargeMember',
            'EvaluateDespatchServicesResponse' => '\\StructType\\EvaluateDespatchServicesResponse',
            'GetStoresResponse' => '\\StructType\\GetStoresResponse',
            'ArrayOfClickCollectStore' => '\\ArrayType\\ArrayOfClickCollectStore',
            'ClickCollectStore' => '\\StructType\\ClickCollectStore',
            'ArrayOfArrayOfKeyValuePairOfstringanyType' => '\\ArrayType\\ArrayOfArrayOfKeyValuePairOfstringanyType',
            'ArrayOfKeyValuePairOfstringanyType' => '\\ArrayType\\ArrayOfKeyValuePairOfstringanyType',
            'KeyValuePairOfstringanyType' => '\\StructType\\KeyValuePairOfstringanyType',
            'ArrayOfBase64Binary' => '\\ArrayType\\ArrayOfBase64Binary',
            'createlabelrequest' => '\\StructType\\Createlabelrequest',
            'CustomsInfo' => '\\StructType\\CustomsInfo',
            'ArrayOfLabel' => '\\ArrayType\\ArrayOfLabel',
            'label' => '\\StructType\\Label',
            'ArrayOfParcel' => '\\ArrayType\\ArrayOfParcel',
            'parcel' => '\\StructType\\Parcel',
            'ArrayOfParcelProduct' => '\\ArrayType\\ArrayOfParcelProduct',
            'parcelProduct' => '\\StructType\\ParcelProduct',
            'ArrayOfProduct' => '\\ArrayType\\ArrayOfProduct',
            'product' => '\\StructType\\Product',
            'createlabelresponse' => '\\StructType\\Createlabelresponse',
            'ArrayOfParcelResponse' => '\\ArrayType\\ArrayOfParcelResponse',
            'parcelResponse' => '\\StructType\\ParcelResponse',
            'ArrayOfSurcharge' => '\\ArrayType\\ArrayOfSurcharge',
            'surcharge' => '\\StructType\\Surcharge',
            'ConfirmDespatchArgs' => '\\StructType\\ConfirmDespatchArgs',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'GetDespatchDetailsRequest' => '\\StructType\\GetDespatchDetailsRequest',
            'updateorderrequest' => '\\StructType\\Updateorderrequest',
            'AddressRequest1' => '\\StructType\\AddressRequest1',
            'ArrayOfProduct1' => '\\ArrayType\\ArrayOfProduct1',
            'product1' => '\\StructType\\Product1',
            'updateorderresponse' => '\\StructType\\Updateorderresponse',
            'ValidateOrderResultArgs' => '\\StructType\\ValidateOrderResultArgs',
            'DespatchOrderResultArgs' => '\\StructType\\DespatchOrderResultArgs',
            'CreateBookingRequest' => '\\StructType\\CreateBookingRequest',
            'BookingOperationResponse' => '\\StructType\\BookingOperationResponse',
            'ExportBookingRequest' => '\\StructType\\ExportBookingRequest',
            'PrintLabelRequest' => '\\StructType\\PrintLabelRequest',
            'PrintLabelResponse' => '\\StructType\\PrintLabelResponse',
            'ReprintLabelRequest' => '\\StructType\\ReprintLabelRequest',
            'ReprintLabelResponse' => '\\StructType\\ReprintLabelResponse',
            'PrintServerLabelAuditRequest' => '\\StructType\\PrintServerLabelAuditRequest',
            'PrintsCountRequest' => '\\StructType\\PrintsCountRequest',
            'PrintsCountResponse' => '\\StructType\\PrintsCountResponse',
            'PrintManifestRequest' => '\\StructType\\PrintManifestRequest',
            'ManifestOperationResponse' => '\\StructType\\ManifestOperationResponse',
            'CreateManifestRequest' => '\\StructType\\CreateManifestRequest',
            'ManifestExportRequest' => '\\StructType\\ManifestExportRequest',
            'TimeSpan' => '\\StructType\\TimeSpan',
            'UpdateConsignmentStatus' => '\\StructType\\UpdateConsignmentStatus',
            'CreateTrackingRequest' => '\\StructType\\CreateTrackingRequest',
            'CreateTrackingResponse' => '\\StructType\\CreateTrackingResponse',
            'CreateNormalisedEventRequest' => '\\StructType\\CreateNormalisedEventRequest',
            'CreateNormalisedEventResponse' => '\\StructType\\CreateNormalisedEventResponse',
            'TrackingRequest' => '\\StructType\\TrackingRequest',
            'EventInfo' => '\\StructType\\EventInfo',
            'ArrayOfEventInfo' => '\\ArrayType\\ArrayOfEventInfo',
            'TrackingResponse' => '\\StructType\\TrackingResponse',
            'ImportTrackingRequest' => '\\StructType\\ImportTrackingRequest',
            'ExportTrackingRequest' => '\\StructType\\ExportTrackingRequest',
            'StoreCustomerOrderRequest' => '\\StructType\\StoreCustomerOrderRequest',
            'ArrayOfSiteDespatch' => '\\ArrayType\\ArrayOfSiteDespatch',
            'SiteDespatch' => '\\StructType\\SiteDespatch',
            'ArrayOfSiteDespatchProduct' => '\\ArrayType\\ArrayOfSiteDespatchProduct',
            'SiteDespatchProduct' => '\\StructType\\SiteDespatchProduct',
            'StoreCustomerOrderResponse' => '\\StructType\\StoreCustomerOrderResponse',
            'GetDiagnosticInfo' => '\\StructType\\GetDiagnosticInfo',
            'GetDiagnosticInfoResponse' => '\\StructType\\GetDiagnosticInfoResponse',
            'GetSpeedTestInfo' => '\\StructType\\GetSpeedTestInfo',
            'GetSpeedTestInfoResponse' => '\\StructType\\GetSpeedTestInfoResponse',
            'GetScriptsRun' => '\\StructType\\GetScriptsRun',
            'GetScriptsRunResponse' => '\\StructType\\GetScriptsRunResponse',
            'ThrowException' => '\\StructType\\ThrowException',
            'ThrowExceptionResponse' => '\\StructType\\ThrowExceptionResponse',
            'TestExceptionLog' => '\\StructType\\TestExceptionLog',
            'TestExceptionLogResponse' => '\\StructType\\TestExceptionLogResponse',
            'TestGeneralLog' => '\\StructType\\TestGeneralLog',
            'TestGeneralLogResponse' => '\\StructType\\TestGeneralLogResponse',
            'AllocateDespatchMethod' => '\\StructType\\AllocateDespatchMethod',
            'AllocateDespatchMethodResponse' => '\\StructType\\AllocateDespatchMethodResponse',
            'ClearCache' => '\\StructType\\ClearCache',
            'ClearCacheResponse' => '\\StructType\\ClearCacheResponse',
            'SetMaintenanceMode' => '\\StructType\\SetMaintenanceMode',
            'SetMaintenanceModeResponse' => '\\StructType\\SetMaintenanceModeResponse',
            'GetMaintenanceMode' => '\\StructType\\GetMaintenanceMode',
            'GetMaintenanceModeResponse' => '\\StructType\\GetMaintenanceModeResponse',
            'DespatchParcel' => '\\StructType\\DespatchParcel',
            'DespatchParcelResponse' => '\\StructType\\DespatchParcelResponse',
            'ConfirmDespatch' => '\\StructType\\ConfirmDespatch',
            'ConfirmDespatchResponse' => '\\StructType\\ConfirmDespatchResponse',
            'BulkDespatchParcel' => '\\StructType\\BulkDespatchParcel',
            'ArrayOfCreatelabelrequest' => '\\ArrayType\\ArrayOfCreatelabelrequest',
            'ArrayOfCreatelabelresponse' => '\\ArrayType\\ArrayOfCreatelabelresponse',
            'BulkDespatchParcelResponse' => '\\StructType\\BulkDespatchParcelResponse',
            'CreateOrder' => '\\StructType\\CreateOrder',
            'CreateOrderResponse' => '\\StructType\\CreateOrderResponse',
            'UpdateOrder' => '\\StructType\\UpdateOrder',
            'UpdateOrderResponse' => '\\StructType\\UpdateOrderResponse_1',
            'CreateBooking' => '\\StructType\\CreateBooking',
            'CreateBookingResponse' => '\\StructType\\CreateBookingResponse',
            'ExportBooking' => '\\StructType\\ExportBooking',
            'ExportBookingResponse' => '\\StructType\\ExportBookingResponse',
            'PrintLabel' => '\\StructType\\PrintLabel',
            'ArrayOfPrintLabelResponse' => '\\ArrayType\\ArrayOfPrintLabelResponse',
            'PrintLabelForDespatchManager' => '\\StructType\\PrintLabelForDespatchManager',
            'PrintLabelForDespatchManagerResponse' => '\\StructType\\PrintLabelForDespatchManagerResponse',
            'ReprintLabel' => '\\StructType\\ReprintLabel',
            'PrintManifest' => '\\StructType\\PrintManifest',
            'PrintManifestResponse' => '\\StructType\\PrintManifestResponse',
            'CreateManifest' => '\\StructType\\CreateManifest',
            'CreateManifestResponse' => '\\StructType\\CreateManifestResponse',
            'ExportManifest' => '\\StructType\\ExportManifest',
            'ExportManifestResponse' => '\\StructType\\ExportManifestResponse',
            'GetManifestedOrders' => '\\StructType\\GetManifestedOrders',
            'GetManifestedOrdersResponse' => '\\StructType\\GetManifestedOrdersResponse',
            'CancelConsignment' => '\\StructType\\CancelConsignment',
            'CancelConsignmentResponse' => '\\StructType\\CancelConsignmentResponse',
            'CreateTrackingEvent' => '\\StructType\\CreateTrackingEvent',
            'CreateTrackingEventResponse' => '\\StructType\\CreateTrackingEventResponse',
            'CreateNormalisedEvent' => '\\StructType\\CreateNormalisedEvent',
            'GetTrackingEvents' => '\\StructType\\GetTrackingEvents',
            'GetTrackingEventsResponse' => '\\StructType\\GetTrackingEventsResponse',
            'StoreCustomerOrder' => '\\StructType\\StoreCustomerOrder',
            'EvaluateDespatchServices' => '\\StructType\\EvaluateDespatchServices',
            'ArrayOfEvaluateDespatchServicesResponse' => '\\ArrayType\\ArrayOfEvaluateDespatchServicesResponse',
            'PreLoadCache' => '\\StructType\\PreLoadCache',
            'PreLoadCacheResponse' => '\\StructType\\PreLoadCacheResponse',
            'GetDespatchDetails' => '\\StructType\\GetDespatchDetails',
            'GetDespatchDetailsResponse' => '\\StructType\\GetDespatchDetailsResponse',
            'GetStores' => '\\StructType\\GetStores',
            'PrintServerAuditLog' => '\\StructType\\PrintServerAuditLog',
            'PrintServerAuditLogResponse' => '\\StructType\\PrintServerAuditLogResponse',
            'ImportOrders' => '\\StructType\\ImportOrders',
            'ImportOrdersResponse' => '\\StructType\\ImportOrdersResponse',
            'ValidateDespatchManagerOrder' => '\\StructType\\ValidateDespatchManagerOrder',
            'ValidateDespatchManagerOrderResponse' => '\\StructType\\ValidateDespatchManagerOrderResponse',
            'DespatchManagedOrder' => '\\StructType\\DespatchManagedOrder',
            'DespatchManagedOrderResponse' => '\\StructType\\DespatchManagedOrderResponse',
            'GetDespatchManagerPrintRequestById' => '\\StructType\\GetDespatchManagerPrintRequestById',
            'GetDespatchManagerPrintRequestByIdResponse' => '\\StructType\\GetDespatchManagerPrintRequestByIdResponse',
            'CreatePreDespatchedOrder' => '\\StructType\\CreatePreDespatchedOrder',
            'CreatePreDespatchedOrderResponse' => '\\StructType\\CreatePreDespatchedOrderResponse',
            'GetParcelPrintsCount' => '\\StructType\\GetParcelPrintsCount',
            'GetParcelPrintsCountResponse' => '\\StructType\\GetParcelPrintsCountResponse',
            'GetOrderPrintsCount' => '\\StructType\\GetOrderPrintsCount',
            'GetOrderPrintsCountResponse' => '\\StructType\\GetOrderPrintsCountResponse',
            'ImportTracking' => '\\StructType\\ImportTracking',
            'ImportTrackingResponse' => '\\StructType\\ImportTrackingResponse',
            'ExportTracking' => '\\StructType\\ExportTracking',
            'ExportTrackingResponse' => '\\StructType\\ExportTrackingResponse',
            'DespatchMethodInvalidRequestFaultContract' => '\\StructType\\DespatchMethodInvalidRequestFaultContract',
        );
    }
}
