<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Allocate ServiceType
 * @subpackage Services
 */
class Allocate extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named AllocateDespatchMethod
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\AllocateDespatchMethod $parameters
     * @return \StructType\AllocateDespatchMethodResponse|bool
     */
    public function AllocateDespatchMethod(\StructType\AllocateDespatchMethod $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->AllocateDespatchMethod($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\AllocateDespatchMethodResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
