<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Throw ServiceType
 * @subpackage Services
 */
class _Throw extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named ThrowException
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\ThrowException $parameters
     * @return \StructType\ThrowExceptionResponse|bool
     */
    public function ThrowException(\StructType\ThrowException $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->ThrowException($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\ThrowExceptionResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
