<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BookingOperationResponse StructType
 * @subpackage Structs
 */
class BookingOperationResponse extends AbstractStructBase
{
    /**
     * The Sucessful
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Sucessful;
    /**
     * The ExtensionData
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ExtensionDataObject
     */
    public $ExtensionData;
    /**
     * The ErrorMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorMessage;
    /**
     * Constructor method for BookingOperationResponse
     * @uses BookingOperationResponse::setSucessful()
     * @uses BookingOperationResponse::setExtensionData()
     * @uses BookingOperationResponse::setErrorMessage()
     * @param bool $sucessful
     * @param \StructType\ExtensionDataObject $extensionData
     * @param string $errorMessage
     */
    public function __construct($sucessful = null, \StructType\ExtensionDataObject $extensionData = null, $errorMessage = null)
    {
        $this
            ->setSucessful($sucessful)
            ->setExtensionData($extensionData)
            ->setErrorMessage($errorMessage);
    }
    /**
     * Get Sucessful value
     * @return bool
     */
    public function getSucessful()
    {
        return $this->Sucessful;
    }
    /**
     * Set Sucessful value
     * @param bool $sucessful
     * @return \StructType\BookingOperationResponse
     */
    public function setSucessful($sucessful = null)
    {
        // validation for constraint: boolean
        if (!is_null($sucessful) && !is_bool($sucessful)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($sucessful, true), gettype($sucessful)), __LINE__);
        }
        $this->Sucessful = $sucessful;
        return $this;
    }
    /**
     * Get ExtensionData value
     * @return \StructType\ExtensionDataObject|null
     */
    public function getExtensionData()
    {
        return $this->ExtensionData;
    }
    /**
     * Set ExtensionData value
     * @param \StructType\ExtensionDataObject $extensionData
     * @return \StructType\BookingOperationResponse
     */
    public function setExtensionData(\StructType\ExtensionDataObject $extensionData = null)
    {
        $this->ExtensionData = $extensionData;
        return $this;
    }
    /**
     * Get ErrorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->ErrorMessage;
    }
    /**
     * Set ErrorMessage value
     * @param string $errorMessage
     * @return \StructType\BookingOperationResponse
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorMessage, true), gettype($errorMessage)), __LINE__);
        }
        $this->ErrorMessage = $errorMessage;
        return $this;
    }
}
