<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ConfirmDespatchArgs StructType
 * @subpackage Structs
 */
class ConfirmDespatchArgs extends AbstractStructBase
{
    /**
     * The ExitOnError
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $ExitOnError;
    /**
     * The ExtensionData
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ExtensionDataObject
     */
    public $ExtensionData;
    /**
     * The ClientCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ClientCode;
    /**
     * The SiteOrders
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $SiteOrders;
    /**
     * Constructor method for ConfirmDespatchArgs
     * @uses ConfirmDespatchArgs::setExitOnError()
     * @uses ConfirmDespatchArgs::setExtensionData()
     * @uses ConfirmDespatchArgs::setClientCode()
     * @uses ConfirmDespatchArgs::setSiteOrders()
     * @param bool $exitOnError
     * @param \StructType\ExtensionDataObject $extensionData
     * @param string $clientCode
     * @param \ArrayType\ArrayOfString $siteOrders
     */
    public function __construct($exitOnError = null, \StructType\ExtensionDataObject $extensionData = null, $clientCode = null, \ArrayType\ArrayOfString $siteOrders = null)
    {
        $this
            ->setExitOnError($exitOnError)
            ->setExtensionData($extensionData)
            ->setClientCode($clientCode)
            ->setSiteOrders($siteOrders);
    }
    /**
     * Get ExitOnError value
     * @return bool
     */
    public function getExitOnError()
    {
        return $this->ExitOnError;
    }
    /**
     * Set ExitOnError value
     * @param bool $exitOnError
     * @return \StructType\ConfirmDespatchArgs
     */
    public function setExitOnError($exitOnError = null)
    {
        // validation for constraint: boolean
        if (!is_null($exitOnError) && !is_bool($exitOnError)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($exitOnError, true), gettype($exitOnError)), __LINE__);
        }
        $this->ExitOnError = $exitOnError;
        return $this;
    }
    /**
     * Get ExtensionData value
     * @return \StructType\ExtensionDataObject|null
     */
    public function getExtensionData()
    {
        return $this->ExtensionData;
    }
    /**
     * Set ExtensionData value
     * @param \StructType\ExtensionDataObject $extensionData
     * @return \StructType\ConfirmDespatchArgs
     */
    public function setExtensionData(\StructType\ExtensionDataObject $extensionData = null)
    {
        $this->ExtensionData = $extensionData;
        return $this;
    }
    /**
     * Get ClientCode value
     * @return string|null
     */
    public function getClientCode()
    {
        return $this->ClientCode;
    }
    /**
     * Set ClientCode value
     * @param string $clientCode
     * @return \StructType\ConfirmDespatchArgs
     */
    public function setClientCode($clientCode = null)
    {
        // validation for constraint: string
        if (!is_null($clientCode) && !is_string($clientCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($clientCode, true), gettype($clientCode)), __LINE__);
        }
        $this->ClientCode = $clientCode;
        return $this;
    }
    /**
     * Get SiteOrders value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getSiteOrders()
    {
        return $this->SiteOrders;
    }
    /**
     * Set SiteOrders value
     * @param \ArrayType\ArrayOfString $siteOrders
     * @return \StructType\ConfirmDespatchArgs
     */
    public function setSiteOrders(\ArrayType\ArrayOfString $siteOrders = null)
    {
        $this->SiteOrders = $siteOrders;
        return $this;
    }
}
