<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateManifestRequest StructType
 * @subpackage Structs
 */
class CreateManifestRequest extends AbstractStructBase
{
    /**
     * The IsLastManifestOfDay
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsLastManifestOfDay;
    /**
     * The ExtensionData
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ExtensionDataObject
     */
    public $ExtensionData;
    /**
     * The CarrierCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CarrierCode;
    /**
     * The CarrierContract
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CarrierContract;
    /**
     * The DespatchSite
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DespatchSite;
    /**
     * The LorryReference
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LorryReference;
    /**
     * The PrinterID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PrinterID;
    /**
     * Constructor method for CreateManifestRequest
     * @uses CreateManifestRequest::setIsLastManifestOfDay()
     * @uses CreateManifestRequest::setExtensionData()
     * @uses CreateManifestRequest::setCarrierCode()
     * @uses CreateManifestRequest::setCarrierContract()
     * @uses CreateManifestRequest::setDespatchSite()
     * @uses CreateManifestRequest::setLorryReference()
     * @uses CreateManifestRequest::setPrinterID()
     * @param bool $isLastManifestOfDay
     * @param \StructType\ExtensionDataObject $extensionData
     * @param string $carrierCode
     * @param string $carrierContract
     * @param string $despatchSite
     * @param string $lorryReference
     * @param string $printerID
     */
    public function __construct($isLastManifestOfDay = null, \StructType\ExtensionDataObject $extensionData = null, $carrierCode = null, $carrierContract = null, $despatchSite = null, $lorryReference = null, $printerID = null)
    {
        $this
            ->setIsLastManifestOfDay($isLastManifestOfDay)
            ->setExtensionData($extensionData)
            ->setCarrierCode($carrierCode)
            ->setCarrierContract($carrierContract)
            ->setDespatchSite($despatchSite)
            ->setLorryReference($lorryReference)
            ->setPrinterID($printerID);
    }
    /**
     * Get IsLastManifestOfDay value
     * @return bool
     */
    public function getIsLastManifestOfDay()
    {
        return $this->IsLastManifestOfDay;
    }
    /**
     * Set IsLastManifestOfDay value
     * @param bool $isLastManifestOfDay
     * @return \StructType\CreateManifestRequest
     */
    public function setIsLastManifestOfDay($isLastManifestOfDay = null)
    {
        // validation for constraint: boolean
        if (!is_null($isLastManifestOfDay) && !is_bool($isLastManifestOfDay)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isLastManifestOfDay, true), gettype($isLastManifestOfDay)), __LINE__);
        }
        $this->IsLastManifestOfDay = $isLastManifestOfDay;
        return $this;
    }
    /**
     * Get ExtensionData value
     * @return \StructType\ExtensionDataObject|null
     */
    public function getExtensionData()
    {
        return $this->ExtensionData;
    }
    /**
     * Set ExtensionData value
     * @param \StructType\ExtensionDataObject $extensionData
     * @return \StructType\CreateManifestRequest
     */
    public function setExtensionData(\StructType\ExtensionDataObject $extensionData = null)
    {
        $this->ExtensionData = $extensionData;
        return $this;
    }
    /**
     * Get CarrierCode value
     * @return string|null
     */
    public function getCarrierCode()
    {
        return $this->CarrierCode;
    }
    /**
     * Set CarrierCode value
     * @param string $carrierCode
     * @return \StructType\CreateManifestRequest
     */
    public function setCarrierCode($carrierCode = null)
    {
        // validation for constraint: string
        if (!is_null($carrierCode) && !is_string($carrierCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($carrierCode, true), gettype($carrierCode)), __LINE__);
        }
        $this->CarrierCode = $carrierCode;
        return $this;
    }
    /**
     * Get CarrierContract value
     * @return string|null
     */
    public function getCarrierContract()
    {
        return $this->CarrierContract;
    }
    /**
     * Set CarrierContract value
     * @param string $carrierContract
     * @return \StructType\CreateManifestRequest
     */
    public function setCarrierContract($carrierContract = null)
    {
        // validation for constraint: string
        if (!is_null($carrierContract) && !is_string($carrierContract)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($carrierContract, true), gettype($carrierContract)), __LINE__);
        }
        $this->CarrierContract = $carrierContract;
        return $this;
    }
    /**
     * Get DespatchSite value
     * @return string|null
     */
    public function getDespatchSite()
    {
        return $this->DespatchSite;
    }
    /**
     * Set DespatchSite value
     * @param string $despatchSite
     * @return \StructType\CreateManifestRequest
     */
    public function setDespatchSite($despatchSite = null)
    {
        // validation for constraint: string
        if (!is_null($despatchSite) && !is_string($despatchSite)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($despatchSite, true), gettype($despatchSite)), __LINE__);
        }
        $this->DespatchSite = $despatchSite;
        return $this;
    }
    /**
     * Get LorryReference value
     * @return string|null
     */
    public function getLorryReference()
    {
        return $this->LorryReference;
    }
    /**
     * Set LorryReference value
     * @param string $lorryReference
     * @return \StructType\CreateManifestRequest
     */
    public function setLorryReference($lorryReference = null)
    {
        // validation for constraint: string
        if (!is_null($lorryReference) && !is_string($lorryReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lorryReference, true), gettype($lorryReference)), __LINE__);
        }
        $this->LorryReference = $lorryReference;
        return $this;
    }
    /**
     * Get PrinterID value
     * @return string|null
     */
    public function getPrinterID()
    {
        return $this->PrinterID;
    }
    /**
     * Set PrinterID value
     * @param string $printerID
     * @return \StructType\CreateManifestRequest
     */
    public function setPrinterID($printerID = null)
    {
        // validation for constraint: string
        if (!is_null($printerID) && !is_string($printerID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($printerID, true), gettype($printerID)), __LINE__);
        }
        $this->PrinterID = $printerID;
        return $this;
    }
}
