<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateTrackingResponse StructType
 * @subpackage Structs
 */
class CreateTrackingResponse extends AbstractStructBase
{
    /**
     * The Ok
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Ok;
    /**
     * The ExtensionData
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ExtensionDataObject
     */
    public $ExtensionData;
    /**
     * The Message
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Message;
    /**
     * Constructor method for CreateTrackingResponse
     * @uses CreateTrackingResponse::setOk()
     * @uses CreateTrackingResponse::setExtensionData()
     * @uses CreateTrackingResponse::setMessage()
     * @param bool $ok
     * @param \StructType\ExtensionDataObject $extensionData
     * @param string $message
     */
    public function __construct($ok = null, \StructType\ExtensionDataObject $extensionData = null, $message = null)
    {
        $this
            ->setOk($ok)
            ->setExtensionData($extensionData)
            ->setMessage($message);
    }
    /**
     * Get Ok value
     * @return bool
     */
    public function getOk()
    {
        return $this->Ok;
    }
    /**
     * Set Ok value
     * @param bool $ok
     * @return \StructType\CreateTrackingResponse
     */
    public function setOk($ok = null)
    {
        // validation for constraint: boolean
        if (!is_null($ok) && !is_bool($ok)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($ok, true), gettype($ok)), __LINE__);
        }
        $this->Ok = $ok;
        return $this;
    }
    /**
     * Get ExtensionData value
     * @return \StructType\ExtensionDataObject|null
     */
    public function getExtensionData()
    {
        return $this->ExtensionData;
    }
    /**
     * Set ExtensionData value
     * @param \StructType\ExtensionDataObject $extensionData
     * @return \StructType\CreateTrackingResponse
     */
    public function setExtensionData(\StructType\ExtensionDataObject $extensionData = null)
    {
        $this->ExtensionData = $extensionData;
        return $this;
    }
    /**
     * Get Message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->Message;
    }
    /**
     * Set Message value
     * @param string $message
     * @return \StructType\CreateTrackingResponse
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($message, true), gettype($message)), __LINE__);
        }
        $this->Message = $message;
        return $this;
    }
}
