<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EvaluateDespatchServicesResponse StructType
 * @subpackage Structs
 */
class EvaluateDespatchServicesResponse extends AbstractStructBase
{
    /**
     * The ExtensionData
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ExtensionDataObject
     */
    public $ExtensionData;
    /**
     * The ClientServiceCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ClientServiceCode;
    /**
     * The ClientServiceDescription
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ClientServiceDescription;
    /**
     * The DespatchAllocatingResponse
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DespatchAllocatingResponse
     */
    public $DespatchAllocatingResponse;
    /**
     * The EvaluateDespatchServicesResult
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfEvaluateDespatchServicesResponse
     */
    public $EvaluateDespatchServicesResult;
    /**
     * Constructor method for EvaluateDespatchServicesResponse
     * @uses EvaluateDespatchServicesResponse::setExtensionData()
     * @uses EvaluateDespatchServicesResponse::setClientServiceCode()
     * @uses EvaluateDespatchServicesResponse::setClientServiceDescription()
     * @uses EvaluateDespatchServicesResponse::setDespatchAllocatingResponse()
     * @uses EvaluateDespatchServicesResponse::setEvaluateDespatchServicesResult()
     * @param \StructType\ExtensionDataObject $extensionData
     * @param string $clientServiceCode
     * @param string $clientServiceDescription
     * @param \StructType\DespatchAllocatingResponse $despatchAllocatingResponse
     * @param \ArrayType\ArrayOfEvaluateDespatchServicesResponse $evaluateDespatchServicesResult
     */
    public function __construct(\StructType\ExtensionDataObject $extensionData = null, $clientServiceCode = null, $clientServiceDescription = null, \StructType\DespatchAllocatingResponse $despatchAllocatingResponse = null, \ArrayType\ArrayOfEvaluateDespatchServicesResponse $evaluateDespatchServicesResult = null)
    {
        $this
            ->setExtensionData($extensionData)
            ->setClientServiceCode($clientServiceCode)
            ->setClientServiceDescription($clientServiceDescription)
            ->setDespatchAllocatingResponse($despatchAllocatingResponse)
            ->setEvaluateDespatchServicesResult($evaluateDespatchServicesResult);
    }
    /**
     * Get ExtensionData value
     * @return \StructType\ExtensionDataObject|null
     */
    public function getExtensionData()
    {
        return $this->ExtensionData;
    }
    /**
     * Set ExtensionData value
     * @param \StructType\ExtensionDataObject $extensionData
     * @return \StructType\EvaluateDespatchServicesResponse
     */
    public function setExtensionData(\StructType\ExtensionDataObject $extensionData = null)
    {
        $this->ExtensionData = $extensionData;
        return $this;
    }
    /**
     * Get ClientServiceCode value
     * @return string|null
     */
    public function getClientServiceCode()
    {
        return $this->ClientServiceCode;
    }
    /**
     * Set ClientServiceCode value
     * @param string $clientServiceCode
     * @return \StructType\EvaluateDespatchServicesResponse
     */
    public function setClientServiceCode($clientServiceCode = null)
    {
        // validation for constraint: string
        if (!is_null($clientServiceCode) && !is_string($clientServiceCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($clientServiceCode, true), gettype($clientServiceCode)), __LINE__);
        }
        $this->ClientServiceCode = $clientServiceCode;
        return $this;
    }
    /**
     * Get ClientServiceDescription value
     * @return string|null
     */
    public function getClientServiceDescription()
    {
        return $this->ClientServiceDescription;
    }
    /**
     * Set ClientServiceDescription value
     * @param string $clientServiceDescription
     * @return \StructType\EvaluateDespatchServicesResponse
     */
    public function setClientServiceDescription($clientServiceDescription = null)
    {
        // validation for constraint: string
        if (!is_null($clientServiceDescription) && !is_string($clientServiceDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($clientServiceDescription, true), gettype($clientServiceDescription)), __LINE__);
        }
        $this->ClientServiceDescription = $clientServiceDescription;
        return $this;
    }
    /**
     * Get DespatchAllocatingResponse value
     * @return \StructType\DespatchAllocatingResponse|null
     */
    public function getDespatchAllocatingResponse()
    {
        return $this->DespatchAllocatingResponse;
    }
    /**
     * Set DespatchAllocatingResponse value
     * @param \StructType\DespatchAllocatingResponse $despatchAllocatingResponse
     * @return \StructType\EvaluateDespatchServicesResponse
     */
    public function setDespatchAllocatingResponse(\StructType\DespatchAllocatingResponse $despatchAllocatingResponse = null)
    {
        $this->DespatchAllocatingResponse = $despatchAllocatingResponse;
        return $this;
    }
    /**
     * Get EvaluateDespatchServicesResult value
     * @return \ArrayType\ArrayOfEvaluateDespatchServicesResponse|null
     */
    public function getEvaluateDespatchServicesResult()
    {
        return $this->EvaluateDespatchServicesResult;
    }
    /**
     * Set EvaluateDespatchServicesResult value
     * @param \ArrayType\ArrayOfEvaluateDespatchServicesResponse $evaluateDespatchServicesResult
     * @return \StructType\EvaluateDespatchServicesResponse
     */
    public function setEvaluateDespatchServicesResult(\ArrayType\ArrayOfEvaluateDespatchServicesResponse $evaluateDespatchServicesResult = null)
    {
        $this->EvaluateDespatchServicesResult = $evaluateDespatchServicesResult;
        return $this;
    }
}
