<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResultArgs StructType
 * @subpackage Structs
 */
class ResultArgs extends AbstractStructBase
{
    /**
     * The Sucessful
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Sucessful;
    /**
     * The ExtensionData
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ExtensionDataObject
     */
    public $ExtensionData;
    /**
     * The Message
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Message;
    /**
     * The StackTrace
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $StackTrace;
    /**
     * Constructor method for ResultArgs
     * @uses ResultArgs::setSucessful()
     * @uses ResultArgs::setExtensionData()
     * @uses ResultArgs::setMessage()
     * @uses ResultArgs::setStackTrace()
     * @param bool $sucessful
     * @param \StructType\ExtensionDataObject $extensionData
     * @param string $message
     * @param string $stackTrace
     */
    public function __construct($sucessful = null, \StructType\ExtensionDataObject $extensionData = null, $message = null, $stackTrace = null)
    {
        $this
            ->setSucessful($sucessful)
            ->setExtensionData($extensionData)
            ->setMessage($message)
            ->setStackTrace($stackTrace);
    }
    /**
     * Get Sucessful value
     * @return bool
     */
    public function getSucessful()
    {
        return $this->Sucessful;
    }
    /**
     * Set Sucessful value
     * @param bool $sucessful
     * @return \StructType\ResultArgs
     */
    public function setSucessful($sucessful = null)
    {
        // validation for constraint: boolean
        if (!is_null($sucessful) && !is_bool($sucessful)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($sucessful, true), gettype($sucessful)), __LINE__);
        }
        $this->Sucessful = $sucessful;
        return $this;
    }
    /**
     * Get ExtensionData value
     * @return \StructType\ExtensionDataObject|null
     */
    public function getExtensionData()
    {
        return $this->ExtensionData;
    }
    /**
     * Set ExtensionData value
     * @param \StructType\ExtensionDataObject $extensionData
     * @return \StructType\ResultArgs
     */
    public function setExtensionData(\StructType\ExtensionDataObject $extensionData = null)
    {
        $this->ExtensionData = $extensionData;
        return $this;
    }
    /**
     * Get Message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->Message;
    }
    /**
     * Set Message value
     * @param string $message
     * @return \StructType\ResultArgs
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($message, true), gettype($message)), __LINE__);
        }
        $this->Message = $message;
        return $this;
    }
    /**
     * Get StackTrace value
     * @return string|null
     */
    public function getStackTrace()
    {
        return $this->StackTrace;
    }
    /**
     * Set StackTrace value
     * @param string $stackTrace
     * @return \StructType\ResultArgs
     */
    public function setStackTrace($stackTrace = null)
    {
        // validation for constraint: string
        if (!is_null($stackTrace) && !is_string($stackTrace)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($stackTrace, true), gettype($stackTrace)), __LINE__);
        }
        $this->StackTrace = $stackTrace;
        return $this;
    }
}
