<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StoreCustomerOrderRequest StructType
 * @subpackage Structs
 */
class StoreCustomerOrderRequest extends AbstractStructBase
{
    /**
     * The AddressLine1
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $AddressLine1;
    /**
     * The AddressLine2
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $AddressLine2;
    /**
     * The AddressLine3
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $AddressLine3;
    /**
     * The AddressLine4
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $AddressLine4;
    /**
     * The ExtensionData
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ExtensionDataObject
     */
    public $ExtensionData;
    /**
     * The ClientCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ClientCode;
    /**
     * The ClientDespatchService
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ClientDespatchService;
    /**
     * The ClientOrderReference
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ClientOrderReference;
    /**
     * The CountryCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CountryCode;
    /**
     * The CountryName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CountryName;
    /**
     * The DeliveryPointCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DeliveryPointCode;
    /**
     * The DeliveryToMobilePhone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DeliveryToMobilePhone;
    /**
     * The DeliveryToPhone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DeliveryToPhone;
    /**
     * The FirstName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FirstName;
    /**
     * The LabelReference
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LabelReference;
    /**
     * The LastName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LastName;
    /**
     * The Products
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfProduct
     */
    public $Products;
    /**
     * The SiteDespatches
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfSiteDespatch
     */
    public $SiteDespatches;
    /**
     * Constructor method for StoreCustomerOrderRequest
     * @uses StoreCustomerOrderRequest::setAddressLine1()
     * @uses StoreCustomerOrderRequest::setAddressLine2()
     * @uses StoreCustomerOrderRequest::setAddressLine3()
     * @uses StoreCustomerOrderRequest::setAddressLine4()
     * @uses StoreCustomerOrderRequest::setExtensionData()
     * @uses StoreCustomerOrderRequest::setClientCode()
     * @uses StoreCustomerOrderRequest::setClientDespatchService()
     * @uses StoreCustomerOrderRequest::setClientOrderReference()
     * @uses StoreCustomerOrderRequest::setCountryCode()
     * @uses StoreCustomerOrderRequest::setCountryName()
     * @uses StoreCustomerOrderRequest::setDeliveryPointCode()
     * @uses StoreCustomerOrderRequest::setDeliveryToMobilePhone()
     * @uses StoreCustomerOrderRequest::setDeliveryToPhone()
     * @uses StoreCustomerOrderRequest::setFirstName()
     * @uses StoreCustomerOrderRequest::setLabelReference()
     * @uses StoreCustomerOrderRequest::setLastName()
     * @uses StoreCustomerOrderRequest::setProducts()
     * @uses StoreCustomerOrderRequest::setSiteDespatches()
     * @param string $addressLine1
     * @param string $addressLine2
     * @param string $addressLine3
     * @param string $addressLine4
     * @param \StructType\ExtensionDataObject $extensionData
     * @param string $clientCode
     * @param string $clientDespatchService
     * @param string $clientOrderReference
     * @param string $countryCode
     * @param string $countryName
     * @param string $deliveryPointCode
     * @param string $deliveryToMobilePhone
     * @param string $deliveryToPhone
     * @param string $firstName
     * @param string $labelReference
     * @param string $lastName
     * @param \ArrayType\ArrayOfProduct $products
     * @param \ArrayType\ArrayOfSiteDespatch $siteDespatches
     */
    public function __construct($addressLine1 = null, $addressLine2 = null, $addressLine3 = null, $addressLine4 = null, \StructType\ExtensionDataObject $extensionData = null, $clientCode = null, $clientDespatchService = null, $clientOrderReference = null, $countryCode = null, $countryName = null, $deliveryPointCode = null, $deliveryToMobilePhone = null, $deliveryToPhone = null, $firstName = null, $labelReference = null, $lastName = null, \ArrayType\ArrayOfProduct $products = null, \ArrayType\ArrayOfSiteDespatch $siteDespatches = null)
    {
        $this
            ->setAddressLine1($addressLine1)
            ->setAddressLine2($addressLine2)
            ->setAddressLine3($addressLine3)
            ->setAddressLine4($addressLine4)
            ->setExtensionData($extensionData)
            ->setClientCode($clientCode)
            ->setClientDespatchService($clientDespatchService)
            ->setClientOrderReference($clientOrderReference)
            ->setCountryCode($countryCode)
            ->setCountryName($countryName)
            ->setDeliveryPointCode($deliveryPointCode)
            ->setDeliveryToMobilePhone($deliveryToMobilePhone)
            ->setDeliveryToPhone($deliveryToPhone)
            ->setFirstName($firstName)
            ->setLabelReference($labelReference)
            ->setLastName($lastName)
            ->setProducts($products)
            ->setSiteDespatches($siteDespatches);
    }
    /**
     * Get AddressLine1 value
     * @return string
     */
    public function getAddressLine1()
    {
        return $this->AddressLine1;
    }
    /**
     * Set AddressLine1 value
     * @param string $addressLine1
     * @return \StructType\StoreCustomerOrderRequest
     */
    public function setAddressLine1($addressLine1 = null)
    {
        // validation for constraint: string
        if (!is_null($addressLine1) && !is_string($addressLine1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($addressLine1, true), gettype($addressLine1)), __LINE__);
        }
        $this->AddressLine1 = $addressLine1;
        return $this;
    }
    /**
     * Get AddressLine2 value
     * @return string
     */
    public function getAddressLine2()
    {
        return $this->AddressLine2;
    }
    /**
     * Set AddressLine2 value
     * @param string $addressLine2
     * @return \StructType\StoreCustomerOrderRequest
     */
    public function setAddressLine2($addressLine2 = null)
    {
        // validation for constraint: string
        if (!is_null($addressLine2) && !is_string($addressLine2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($addressLine2, true), gettype($addressLine2)), __LINE__);
        }
        $this->AddressLine2 = $addressLine2;
        return $this;
    }
    /**
     * Get AddressLine3 value
     * @return string
     */
    public function getAddressLine3()
    {
        return $this->AddressLine3;
    }
    /**
     * Set AddressLine3 value
     * @param string $addressLine3
     * @return \StructType\StoreCustomerOrderRequest
     */
    public function setAddressLine3($addressLine3 = null)
    {
        // validation for constraint: string
        if (!is_null($addressLine3) && !is_string($addressLine3)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($addressLine3, true), gettype($addressLine3)), __LINE__);
        }
        $this->AddressLine3 = $addressLine3;
        return $this;
    }
    /**
     * Get AddressLine4 value
     * @return string
     */
    public function getAddressLine4()
    {
        return $this->AddressLine4;
    }
    /**
     * Set AddressLine4 value
     * @param string $addressLine4
     * @return \StructType\StoreCustomerOrderRequest
     */
    public function setAddressLine4($addressLine4 = null)
    {
        // validation for constraint: string
        if (!is_null($addressLine4) && !is_string($addressLine4)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($addressLine4, true), gettype($addressLine4)), __LINE__);
        }
        $this->AddressLine4 = $addressLine4;
        return $this;
    }
    /**
     * Get ExtensionData value
     * @return \StructType\ExtensionDataObject|null
     */
    public function getExtensionData()
    {
        return $this->ExtensionData;
    }
    /**
     * Set ExtensionData value
     * @param \StructType\ExtensionDataObject $extensionData
     * @return \StructType\StoreCustomerOrderRequest
     */
    public function setExtensionData(\StructType\ExtensionDataObject $extensionData = null)
    {
        $this->ExtensionData = $extensionData;
        return $this;
    }
    /**
     * Get ClientCode value
     * @return string|null
     */
    public function getClientCode()
    {
        return $this->ClientCode;
    }
    /**
     * Set ClientCode value
     * @param string $clientCode
     * @return \StructType\StoreCustomerOrderRequest
     */
    public function setClientCode($clientCode = null)
    {
        // validation for constraint: string
        if (!is_null($clientCode) && !is_string($clientCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($clientCode, true), gettype($clientCode)), __LINE__);
        }
        $this->ClientCode = $clientCode;
        return $this;
    }
    /**
     * Get ClientDespatchService value
     * @return string|null
     */
    public function getClientDespatchService()
    {
        return $this->ClientDespatchService;
    }
    /**
     * Set ClientDespatchService value
     * @param string $clientDespatchService
     * @return \StructType\StoreCustomerOrderRequest
     */
    public function setClientDespatchService($clientDespatchService = null)
    {
        // validation for constraint: string
        if (!is_null($clientDespatchService) && !is_string($clientDespatchService)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($clientDespatchService, true), gettype($clientDespatchService)), __LINE__);
        }
        $this->ClientDespatchService = $clientDespatchService;
        return $this;
    }
    /**
     * Get ClientOrderReference value
     * @return string|null
     */
    public function getClientOrderReference()
    {
        return $this->ClientOrderReference;
    }
    /**
     * Set ClientOrderReference value
     * @param string $clientOrderReference
     * @return \StructType\StoreCustomerOrderRequest
     */
    public function setClientOrderReference($clientOrderReference = null)
    {
        // validation for constraint: string
        if (!is_null($clientOrderReference) && !is_string($clientOrderReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($clientOrderReference, true), gettype($clientOrderReference)), __LINE__);
        }
        $this->ClientOrderReference = $clientOrderReference;
        return $this;
    }
    /**
     * Get CountryCode value
     * @return string|null
     */
    public function getCountryCode()
    {
        return $this->CountryCode;
    }
    /**
     * Set CountryCode value
     * @param string $countryCode
     * @return \StructType\StoreCustomerOrderRequest
     */
    public function setCountryCode($countryCode = null)
    {
        // validation for constraint: string
        if (!is_null($countryCode) && !is_string($countryCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($countryCode, true), gettype($countryCode)), __LINE__);
        }
        $this->CountryCode = $countryCode;
        return $this;
    }
    /**
     * Get CountryName value
     * @return string|null
     */
    public function getCountryName()
    {
        return $this->CountryName;
    }
    /**
     * Set CountryName value
     * @param string $countryName
     * @return \StructType\StoreCustomerOrderRequest
     */
    public function setCountryName($countryName = null)
    {
        // validation for constraint: string
        if (!is_null($countryName) && !is_string($countryName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($countryName, true), gettype($countryName)), __LINE__);
        }
        $this->CountryName = $countryName;
        return $this;
    }
    /**
     * Get DeliveryPointCode value
     * @return string|null
     */
    public function getDeliveryPointCode()
    {
        return $this->DeliveryPointCode;
    }
    /**
     * Set DeliveryPointCode value
     * @param string $deliveryPointCode
     * @return \StructType\StoreCustomerOrderRequest
     */
    public function setDeliveryPointCode($deliveryPointCode = null)
    {
        // validation for constraint: string
        if (!is_null($deliveryPointCode) && !is_string($deliveryPointCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deliveryPointCode, true), gettype($deliveryPointCode)), __LINE__);
        }
        $this->DeliveryPointCode = $deliveryPointCode;
        return $this;
    }
    /**
     * Get DeliveryToMobilePhone value
     * @return string|null
     */
    public function getDeliveryToMobilePhone()
    {
        return $this->DeliveryToMobilePhone;
    }
    /**
     * Set DeliveryToMobilePhone value
     * @param string $deliveryToMobilePhone
     * @return \StructType\StoreCustomerOrderRequest
     */
    public function setDeliveryToMobilePhone($deliveryToMobilePhone = null)
    {
        // validation for constraint: string
        if (!is_null($deliveryToMobilePhone) && !is_string($deliveryToMobilePhone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deliveryToMobilePhone, true), gettype($deliveryToMobilePhone)), __LINE__);
        }
        $this->DeliveryToMobilePhone = $deliveryToMobilePhone;
        return $this;
    }
    /**
     * Get DeliveryToPhone value
     * @return string|null
     */
    public function getDeliveryToPhone()
    {
        return $this->DeliveryToPhone;
    }
    /**
     * Set DeliveryToPhone value
     * @param string $deliveryToPhone
     * @return \StructType\StoreCustomerOrderRequest
     */
    public function setDeliveryToPhone($deliveryToPhone = null)
    {
        // validation for constraint: string
        if (!is_null($deliveryToPhone) && !is_string($deliveryToPhone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deliveryToPhone, true), gettype($deliveryToPhone)), __LINE__);
        }
        $this->DeliveryToPhone = $deliveryToPhone;
        return $this;
    }
    /**
     * Get FirstName value
     * @return string|null
     */
    public function getFirstName()
    {
        return $this->FirstName;
    }
    /**
     * Set FirstName value
     * @param string $firstName
     * @return \StructType\StoreCustomerOrderRequest
     */
    public function setFirstName($firstName = null)
    {
        // validation for constraint: string
        if (!is_null($firstName) && !is_string($firstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firstName, true), gettype($firstName)), __LINE__);
        }
        $this->FirstName = $firstName;
        return $this;
    }
    /**
     * Get LabelReference value
     * @return string|null
     */
    public function getLabelReference()
    {
        return $this->LabelReference;
    }
    /**
     * Set LabelReference value
     * @param string $labelReference
     * @return \StructType\StoreCustomerOrderRequest
     */
    public function setLabelReference($labelReference = null)
    {
        // validation for constraint: string
        if (!is_null($labelReference) && !is_string($labelReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($labelReference, true), gettype($labelReference)), __LINE__);
        }
        $this->LabelReference = $labelReference;
        return $this;
    }
    /**
     * Get LastName value
     * @return string|null
     */
    public function getLastName()
    {
        return $this->LastName;
    }
    /**
     * Set LastName value
     * @param string $lastName
     * @return \StructType\StoreCustomerOrderRequest
     */
    public function setLastName($lastName = null)
    {
        // validation for constraint: string
        if (!is_null($lastName) && !is_string($lastName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastName, true), gettype($lastName)), __LINE__);
        }
        $this->LastName = $lastName;
        return $this;
    }
    /**
     * Get Products value
     * @return \ArrayType\ArrayOfProduct|null
     */
    public function getProducts()
    {
        return $this->Products;
    }
    /**
     * Set Products value
     * @param \ArrayType\ArrayOfProduct $products
     * @return \StructType\StoreCustomerOrderRequest
     */
    public function setProducts(\ArrayType\ArrayOfProduct $products = null)
    {
        $this->Products = $products;
        return $this;
    }
    /**
     * Get SiteDespatches value
     * @return \ArrayType\ArrayOfSiteDespatch|null
     */
    public function getSiteDespatches()
    {
        return $this->SiteDespatches;
    }
    /**
     * Set SiteDespatches value
     * @param \ArrayType\ArrayOfSiteDespatch $siteDespatches
     * @return \StructType\StoreCustomerOrderRequest
     */
    public function setSiteDespatches(\ArrayType\ArrayOfSiteDespatch $siteDespatches = null)
    {
        $this->SiteDespatches = $siteDespatches;
        return $this;
    }
}
