<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for updateorderrequest StructType
 * @subpackage Structs
 */
class Updateorderrequest extends AbstractStructBase
{
    /**
     * The IsReturnsOrder
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsReturnsOrder;
    /**
     * The ExtensionData
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ExtensionDataObject
     */
    public $ExtensionData;
    /**
     * The ClientCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ClientCode;
    /**
     * The ClientSiteOrderReference
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ClientSiteOrderReference;
    /**
     * The DeliveryAddress
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\AddressRequest1
     */
    public $DeliveryAddress;
    /**
     * The Products
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfProduct1
     */
    public $Products;
    /**
     * The ReturnAddress
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\AddressRequest1
     */
    public $ReturnAddress;
    /**
     * Constructor method for updateorderrequest
     * @uses Updateorderrequest::setIsReturnsOrder()
     * @uses Updateorderrequest::setExtensionData()
     * @uses Updateorderrequest::setClientCode()
     * @uses Updateorderrequest::setClientSiteOrderReference()
     * @uses Updateorderrequest::setDeliveryAddress()
     * @uses Updateorderrequest::setProducts()
     * @uses Updateorderrequest::setReturnAddress()
     * @param bool $isReturnsOrder
     * @param \StructType\ExtensionDataObject $extensionData
     * @param string $clientCode
     * @param string $clientSiteOrderReference
     * @param \StructType\AddressRequest1 $deliveryAddress
     * @param \ArrayType\ArrayOfProduct1 $products
     * @param \StructType\AddressRequest1 $returnAddress
     */
    public function __construct($isReturnsOrder = null, \StructType\ExtensionDataObject $extensionData = null, $clientCode = null, $clientSiteOrderReference = null, \StructType\AddressRequest1 $deliveryAddress = null, \ArrayType\ArrayOfProduct1 $products = null, \StructType\AddressRequest1 $returnAddress = null)
    {
        $this
            ->setIsReturnsOrder($isReturnsOrder)
            ->setExtensionData($extensionData)
            ->setClientCode($clientCode)
            ->setClientSiteOrderReference($clientSiteOrderReference)
            ->setDeliveryAddress($deliveryAddress)
            ->setProducts($products)
            ->setReturnAddress($returnAddress);
    }
    /**
     * Get IsReturnsOrder value
     * @return bool
     */
    public function getIsReturnsOrder()
    {
        return $this->IsReturnsOrder;
    }
    /**
     * Set IsReturnsOrder value
     * @param bool $isReturnsOrder
     * @return \StructType\Updateorderrequest
     */
    public function setIsReturnsOrder($isReturnsOrder = null)
    {
        // validation for constraint: boolean
        if (!is_null($isReturnsOrder) && !is_bool($isReturnsOrder)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isReturnsOrder, true), gettype($isReturnsOrder)), __LINE__);
        }
        $this->IsReturnsOrder = $isReturnsOrder;
        return $this;
    }
    /**
     * Get ExtensionData value
     * @return \StructType\ExtensionDataObject|null
     */
    public function getExtensionData()
    {
        return $this->ExtensionData;
    }
    /**
     * Set ExtensionData value
     * @param \StructType\ExtensionDataObject $extensionData
     * @return \StructType\Updateorderrequest
     */
    public function setExtensionData(\StructType\ExtensionDataObject $extensionData = null)
    {
        $this->ExtensionData = $extensionData;
        return $this;
    }
    /**
     * Get ClientCode value
     * @return string|null
     */
    public function getClientCode()
    {
        return $this->ClientCode;
    }
    /**
     * Set ClientCode value
     * @param string $clientCode
     * @return \StructType\Updateorderrequest
     */
    public function setClientCode($clientCode = null)
    {
        // validation for constraint: string
        if (!is_null($clientCode) && !is_string($clientCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($clientCode, true), gettype($clientCode)), __LINE__);
        }
        $this->ClientCode = $clientCode;
        return $this;
    }
    /**
     * Get ClientSiteOrderReference value
     * @return string|null
     */
    public function getClientSiteOrderReference()
    {
        return $this->ClientSiteOrderReference;
    }
    /**
     * Set ClientSiteOrderReference value
     * @param string $clientSiteOrderReference
     * @return \StructType\Updateorderrequest
     */
    public function setClientSiteOrderReference($clientSiteOrderReference = null)
    {
        // validation for constraint: string
        if (!is_null($clientSiteOrderReference) && !is_string($clientSiteOrderReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($clientSiteOrderReference, true), gettype($clientSiteOrderReference)), __LINE__);
        }
        $this->ClientSiteOrderReference = $clientSiteOrderReference;
        return $this;
    }
    /**
     * Get DeliveryAddress value
     * @return \StructType\AddressRequest1|null
     */
    public function getDeliveryAddress()
    {
        return $this->DeliveryAddress;
    }
    /**
     * Set DeliveryAddress value
     * @param \StructType\AddressRequest1 $deliveryAddress
     * @return \StructType\Updateorderrequest
     */
    public function setDeliveryAddress(\StructType\AddressRequest1 $deliveryAddress = null)
    {
        $this->DeliveryAddress = $deliveryAddress;
        return $this;
    }
    /**
     * Get Products value
     * @return \ArrayType\ArrayOfProduct1|null
     */
    public function getProducts()
    {
        return $this->Products;
    }
    /**
     * Set Products value
     * @param \ArrayType\ArrayOfProduct1 $products
     * @return \StructType\Updateorderrequest
     */
    public function setProducts(\ArrayType\ArrayOfProduct1 $products = null)
    {
        $this->Products = $products;
        return $this;
    }
    /**
     * Get ReturnAddress value
     * @return \StructType\AddressRequest1|null
     */
    public function getReturnAddress()
    {
        return $this->ReturnAddress;
    }
    /**
     * Set ReturnAddress value
     * @param \StructType\AddressRequest1 $returnAddress
     * @return \StructType\Updateorderrequest
     */
    public function setReturnAddress(\StructType\AddressRequest1 $returnAddress = null)
    {
        $this->ReturnAddress = $returnAddress;
        return $this;
    }
}
